/*******************************************************************************
 * FoxChatUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxChatUI extends Object within FoxUI
    native(UI);

enum FoxUIChatMode
{
    FCM_GLOBAL,
    FCM_LOBBY,
    FCM_TEAM,
    FCM_CLAN,
    FCM_PARTY,
    FCM_WHISPER,
    FCM_HELP,
    FCM_MAX
};

struct native ChatRoom
{
    var FoxChatUI.FoxUIChatMode Mode;
    var string ChannelID;
    var string ChannelName;
    var string UIButtonPath;
    var bool IsListenedTo;
    var bool IsEnabled;
    var int UnreadCount;
    var bool bMustJoinOnline;
    var bool bJoinedManually;

    structdefaultproperties
    {
        Mode=FoxUIChatMode.FCM_GLOBAL
        ChannelID=""
        ChannelName=""
        UIButtonPath=""
        IsListenedTo=false
        IsEnabled=false
        UnreadCount=0
        bMustJoinOnline=false
        bJoinedManually=false
    }
};

var array<string> HTMLUnsanitized;
var array<string> HTMLSanitized;
var const localized array<localized string> FilteredChatWords;
var const string FilteredChatString;
var const localized array<localized string> ChatSlashCommands;
var const localized array<localized string> SlashCommands;
var int CurrentChatMode;
var string ReplyPlayer;
var array<ChatRoom> AllChannels;
var bool UIReadyForDefaultMessage;
var bool ClanInterfaceReadyForDefaultMessage;
var bool bNewClanMOTD;
var bool bHasShownHelpMessage;
var private int OutstandingChatMessages;
var private const int MaxOutstandingChatMessages;
var private const float TimeCycle;
var private float ChatTimerRemaining;
var string PendingChatLogs[FoxUIChatMode];
var const int ChatPruneLimits[FoxUIChatMode];
var delegate<OnFilterChatComplete> __OnFilterChatComplete__Delegate;

function Initialize()
{
    local ChatRoom NewRoom;
    local byte LoggedInStatus;

    PrepareBadWordsArray();
    NewRoom.Mode = 1;
    NewRoom.ChannelName = Outer.LocalizeChat("LobbyChatModeString");
    NewRoom.IsListenedTo = true;
    NewRoom.bMustJoinOnline = false;
    NewRoom.bJoinedManually = false;
    AllChannels[1] = NewRoom;
    NewRoom.Mode = 2;
    NewRoom.ChannelName = Outer.LocalizeChat("TeamChatModeString");
    AllChannels[2] = NewRoom;
    NewRoom.Mode = 5;
    NewRoom.ChannelName = Outer.LocalizeChat("WhisperChatModeString");
    NewRoom.IsEnabled = true;
    NewRoom.IsListenedTo = false;
    AllChannels[5] = NewRoom;
    ReplyPlayer = "";
    // End:0x2A4
    if(class'FoxGameMP_BO' == Outer.PCOwner.WorldInfo.GetGameClass())
    {
        CreateChatButtons();
    }
    // End:0x362
    if(NotEqual_InterfaceInterface(Outer.PlayerInterface, (none)))
    {
        Outer.PlayerInterface.AddLogoutCompletedDelegate(0, ClearDefaultLogs);
        LoggedInStatus = Outer.PlayerInterface.GetLoginStatus(0);
    }
    // End:0x4F6
    if(NotEqual_InterfaceInterface(Outer.ChatInterface, (none)))
    {
        Outer.ChatInterface.AddOnReceiveChatDelegate(OnSocialServerMessage);
        Outer.ChatInterface.AddOnGetChatList(ParseChatList);
        Outer.ChatInterface.AddChatChannelDelegate(AddChatChannel);
        Outer.ChatInterface.AddOnReceiveWhisperDelegate(ReceiveWhisper);
        // End:0x4F6
        if(LoggedInStatus == 2)
        {
            Outer.ChatInterface.GetChatList();
        }
    }
    PendingChatLogs[5] = Outer.MenuItemsDataStore.SavedWhisperChat;
    PendingChatLogs[0] = Outer.MenuItemsDataStore.SavedGlobalChat;
    PendingChatLogs[4] = Outer.MenuItemsDataStore.SavedPartyChat;
    PendingChatLogs[3] = Outer.MenuItemsDataStore.SavedClanChat;
    ui_SetDefaultChatChannel();
    //return;    
}

function Cleanup()
{
    // End:0x14D
    if(NotEqual_InterfaceInterface(Outer.ChatInterface, (none)))
    {
        Outer.ChatInterface.ClearOnReceiveChatDelegate(OnSocialServerMessage);
        Outer.ChatInterface.ClearOnGetChatList(ParseChatList);
        Outer.ChatInterface.ClearChatChannelDelegate(AddChatChannel);
        Outer.ChatInterface.ClearOnReceiveWhisperDelegate(ReceiveWhisper);
    }
    // End:0x1CA
    if(NotEqual_InterfaceInterface(Outer.PlayerInterface, (none)))
    {
        Outer.PlayerInterface.ClearLogoutCompletedDelegate(0, ClearDefaultLogs);
    }
    Outer.MenuItemsDataStore.SavedCollapsableChatStaus = as_QueryCollaspableChatStatus();
    Outer.MenuItemsDataStore.SavedGlobalChat = as_QueryChatLogByIndex(0);
    Outer.MenuItemsDataStore.SavedClanChat = ((AllChannels[3].IsEnabled) ? as_QueryChatLogByIndex(3) : "");
    Outer.MenuItemsDataStore.SavedWhisperChat = as_QueryChatLogByIndex(5);
    Outer.MenuItemsDataStore.SavedPartyChat = ((AllChannels[4].IsEnabled) ? as_QueryChatLogByIndex(4) : "");
    CleanupFilterTasks();
    ClearChatTimer();
    //return;    
}

// Export UFoxChatUI::execCleanupFilterTasks(FFrame&, void* const)
native function CleanupFilterTasks();

function SubmitChat(string MessageText)
{
    // End:0x3B
    if((MessageText != "") && CheckForSlashCommands(MessageText))
    {
        AddNewChatMessage(MessageText);
    }
    Outer.PCOwner.MyFoxHud.CloseChatWindow();
    //return;    
}

function AddNewChatMessage(string MessageText)
{
    local PlayerReplicationInfo PRI;
    local name ChatType;

    // End:0xB7
    if(!AllChannels[CurrentChatMode].IsListenedTo)
    {
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_SendToDisabledChannel"));
        return;
    }
    // End:0x15A
    if(OutstandingChatMessages >= MaxOutstandingChatMessages)
    {
        StartChatTimer();
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_StopSpamming"));
        return;
    }
    ++ OutstandingChatMessages;
    // End:0x180
    if(ChatTimerRemaining == float(0))
    {
        StartChatTimer();
    }
    // End:0x21B
    if(!CheckCharacterSpam(MessageText))
    {
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_CharacterSpam"));
        return;
    }
    // End:0x2D0
    if(CurrentChatMode == 2)
    {
        // End:0x2BA
        if(!IsTeamChatAvailable())
        {
            UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_TeamChatNA"));
            return;
        }
        ChatType = 'T';
    }
    // End:0x308
    else
    {
        // End:0x2F5
        if(CurrentChatMode == 1)
        {
            ChatType = 'L';
        }
        // End:0x308
        else
        {
            ChatType = 'S';
        }
    }
    PRI = Outer.PCOwner.PlayerReplicationInfo;
    // End:0x3EA
    if(ChatType != 'S')
    {
        Outer.PCOwner.ServerSendChatMsg(MessageText, ChatType);
        DisplayChatMessage(PRI.PlayerName, MessageText, -1, FoxPRI(PRI));
    }
    // End:0x461
    if(CurrentChatMode != 5)
    {
        Outer.ChatInterface.SendChat(AllChannels[CurrentChatMode].ChannelID, MessageText);
    }
    // End:0x492
    else
    {
        // End:0x490
        if(ReplyPlayer != "")
        {
            SendWhisper(ReplyPlayer, MessageText);
        }
        // End:0x492
        else
        {
            return;
        }
    }
    //return;    
}

function bool IsTeamChatAvailable()
{
    return (IsSpectator()) || Outer.IsTeamGame() && (Outer.Menu == none) || ((Outer.Menu != none) && Outer.Menu.Lobby != none) && Outer.Menu.Lobby.LobbyType != 0;
    //return ReturnValue;    
}

function bool IsLobbyChatAvailable()
{
    // End:0xB9
    if(!class'WorldInfo'.static.IsConsoleBuild())
    {
        return !IsSpectator() && !Outer.IsInEntryMap() || (Outer.Menu != none) && Outer.Menu.Lobby != none;
    }
    return false;
    //return ReturnValue;    
}

function bool IsGlobalChatAvailable()
{
    return !Outer.PCOwner.ProfileSettings.IsFlagEnabled(200, 5);
    //return ReturnValue;    
}

function bool IsSpectator()
{
    return (Outer.PCOwner.PlayerReplicationInfo != none) && Outer.PCOwner.PlayerReplicationInfo.bOnlySpectator;
    //return ReturnValue;    
}

function bool IsActiveLog(int Index)
{
    return (CurrentChatMode == Index) && Outer.Menu != none;
    //return ReturnValue;    
}

delegate OnFilterChatComplete(string PlayerName, string Message, int ChannelIdx, FoxPRI PRI)
{
    //return;    
}

// Export UFoxChatUI::execFilterChat(FFrame&, void* const)
native function FilterChat(string PlayerName, string PlayerMessage, delegate<OnFilterChatComplete> FilterCallback, int ChannelIdx, FoxPRI PRI);

// Export UFoxChatUI::execCheckCharacterSpam(FFrame&, void* const)
native function bool CheckCharacterSpam(string PlayerMessage);

// Export UFoxChatUI::execCheckForSlashCommands(FFrame&, void* const)
native function bool CheckForSlashCommands(out string Message);

event ProcessChatSlashCommand(int ComIndex)
{
    switch(ComIndex)
    {
        // End:0x17
        case 0:
        // End:0x1B
        case 1:
        // End:0x20
        case 2:
        // End:0x33
        case 3:
            SmartModeChange(1);
            // End:0xB5
            break;
        // End:0x38
        case 4:
        // End:0x4C
        case 5:
            SmartModeChange(2);
            // End:0xB5
            break;
        // End:0x51
        case 6:
        // End:0x65
        case 7:
            SmartModeChange(3);
            // End:0xB5
            break;
        // End:0x6A
        case 8:
        // End:0x7D
        case 9:
            SmartModeChange(0);
            // End:0xB5
            break;
        // End:0x82
        case 10:
        // End:0x96
        case 11:
            SmartModeChange(4);
            // End:0xB5
            break;
        // End:0x9B
        case 12:
        // End:0xAF
        case 13:
            SmartModeChange(6);
            // End:0xB5
            break;
        // End:0xFFFF
        default:
            // End:0xB5
            break;
    }
    //return;    
}

event ProcessSlashCommand(int ComIndex, optional string Message)
{
    switch(ComIndex)
    {
        // End:0x18
        case 0:
        // End:0x3E
        case 1:
            Outer.ei_exitGame();
            // End:0x49D
            break;
        // End:0x6C
        case 2:
            GetNextWord(Message);
            JoinChatChannel(Message);
            // End:0x49D
            break;
        // End:0x9A
        case 3:
            GetNextWord(Message);
            LeaveChatChannel(Message);
            // End:0x49D
            break;
        // End:0x9F
        case 4:
        // End:0xE3
        case 5:
            GetNextWord(Message);
            Outer.InviteToClan(Message);
            // End:0x49D
            break;
        // End:0xE8
        case 6:
        // End:0x110
        case 7:
            Outer.ei_LeaveClan();
            // End:0x49D
            break;
        // End:0x115
        case 8:
        // End:0x13D
        case 9:
            Outer.ei_ClanDisband();
            // End:0x49D
            break;
        // End:0x142
        case 10:
        // End:0x185
        case 11:
            GetNextWord(Message);
            Outer.KickFromClanByName(Message);
            // End:0x49D
            break;
        // End:0x18A
        case 12:
        // End:0x192
        case 13:
            // End:0x49D
            break;
        // End:0x197
        case 14:
        // End:0x19F
        case 15:
            // End:0x49D
            break;
        // End:0x1E2
        case 16:
            GetNextWord(Message);
            Outer.ei_AddFriend(Message);
            // End:0x49D
            break;
        // End:0x1E7
        case 17:
        // End:0x22A
        case 18:
            GetNextWord(Message);
            Outer.IgnorePlayer(Message);
            // End:0x49D
            break;
        // End:0x22F
        case 19:
        // End:0x272
        case 20:
            GetNextWord(Message);
            Outer.UnIgnorePlayer(Message);
            // End:0x49D
            break;
        // End:0x28D
        case 21:
            TwitterLogin(Message);
            // End:0x49D
            break;
        // End:0x2A8
        case 22:
            Tweet(Message);
            // End:0x49D
            break;
        // End:0x2AD
        case 23:
        // End:0x2F0
        case 24:
            GetNextWord(Message);
            Outer.ChatCommandBanPlayer(Message);
            // End:0x49D
            break;
        // End:0x2F5
        case 25:
        // End:0x338
        case 26:
            GetNextWord(Message);
            Outer.ChatCommandUnBanPlayer(Message);
            // End:0x49D
            break;
        // End:0x33D
        case 27:
        // End:0x380
        case 28:
            GetNextWord(Message);
            Outer.ChatCommandKickPlayer(Message);
            // End:0x49D
            break;
        // End:0x385
        case 29:
        // End:0x3C8
        case 30:
            GetNextWord(Message);
            Outer.ChatCommandWhitelistPlayer(Message);
            // End:0x49D
            break;
        // End:0x3CD
        case 31:
        // End:0x410
        case 32:
            GetNextWord(Message);
            Outer.ChatCommandWhitelistClan(Message);
            // End:0x49D
            break;
        // End:0x415
        case 33:
        // End:0x445
        case 34:
            Outer.ChatCommandAddAdmin(Message);
            // End:0x49D
            break;
        // End:0x44A
        case 35:
        // End:0x47A
        case 36:
            Outer.ChatCommandRemoveAdmin(Message);
            // End:0x49D
            break;
        // End:0x497
        case SlashCommands.Length - 1:
            PrintHelp();
            // End:0x49D
            break;
        // End:0xFFFF
        default:
            // End:0x49D
            break;
    }
    //return;    
}

private final function TwitterLogin(string Message)
{
    local array<string> Tokens;

    Tokens = SplitString(Message, " ", true);
    // End:0xA7
    if(Tokens.Length == 2)
    {
        Outer.HandleTwitterLogin(((Outer.PCOwner.TwitterLogin(Tokens[0], Tokens[1])) ? 0 : 1));
    }
    // End:0x16B
    else
    {
        // End:0xF2
        if(Outer.Menu != none)
        {
            Outer.ShowTwitterLoginBox(false, "");
        }
        // End:0x16B
        else
        {
            UpdateCurrentLog(Outer.LocalizeTwitter("ChatError_TwitterName"), Outer.LocalizeTwitter("ChatError_LoginFailText"));
        }
    }
    //return;    
}

private final function Tweet(string Message)
{
    // End:0x86
    if(Message == "")
    {
        UpdateCurrentLog(Outer.LocalizeTwitter("ChatError_TwitterName"), Outer.LocalizeTwitter("ChatError_EmptyTweet"));
    }
    // End:0x110
    if(Outer.IsTwitterLoggedIn())
    {
        Outer.HandleTweetSent(((Outer.PCOwner.Tweet(Message)) ? 0 : 1));
    }
    // End:0x1D6
    else
    {
        // End:0x15F
        if(Outer.Menu != none)
        {
            Outer.TrySendTweet(Message);
        }
        // End:0x1D6
        else
        {
            UpdateCurrentLog(Outer.LocalizeTwitter("ChatError_TwitterName"), Outer.LocalizeTwitter("ChatError_NotLoggedIn"));
        }
    }
    //return;    
}

event ProcessNumericSlashCommand(int Index, string Message)
{
    // End:0x53
    if(AllChannels[Index].IsEnabled)
    {
        SmartModeChange(Index);
        AddNewChatMessage(Message);
    }
    // End:0xDA
    else
    {
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_InvalidNumericSlash"));
    }
    //return;    
}

function GetNextWord(out string Message)
{
    // End:0x4E
    if(Message != "")
    {
        Message $= " ";
        Message = Left(Message, InStr(Message, " "));
    }
    //return;    
}

// Export UFoxChatUI::execPrintHelp(FFrame&, void* const)
native function PrintHelp();

// Export UFoxChatUI::execCheckForDevCommands(FFrame&, void* const)
native function bool CheckForDevCommands(string Message);

function ParseWhisperCommand(string Message)
{
    local string PlayerName, PlayerMessage;
    local int Index;

    SmartModeChange(5);
    Index = InStr(Message, " ");
    // End:0xC6
    if(Index == -1)
    {
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_WhisperFailedBadFormat"));
        return;
    }
    PlayerName = Left(Message, Index);
    PlayerMessage = Mid(Message, Index + 1);
    // End:0x135
    if(PlayerMessage != "")
    {
        SendWhisper(PlayerName, PlayerMessage);
    }
    // End:0x1B2
    else
    {
        UpdateCurrentLog(Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_EmptyText"));
    }
    //return;    
}

function ei_chatTabClicked(int ChatIndex)
{
    local int I;

    I = AllChannels.Find('Mode', byte(ChatIndex));
    // End:0x51
    if(I != -1)
    {
        ChangeChatMode(I);
    }
    //return;    
}

function ChangeChatMode(int NewMode)
{
    local string FormattedChannelName;

    CurrentChatMode = NewMode;
    FormattedChannelName = GetCurrentChannelName();
    as_UpdateHUDInputString(FormattedChannelName);
    // End:0x14A
    if(Outer.Menu != none)
    {
        Outer.as_SetStringParam(FormattedChannelName, "sayText", Outer.UIPanelPath);
        as_ShowChat(AllChannels[CurrentChatMode].Mode);
        AllChannels[CurrentChatMode].UnreadCount = 0;
        SetUnreadCount(AllChannels[CurrentChatMode]);
        as_PruneChatLog(NewMode, ChatPruneLimits[NewMode]);
    }
    //return;    
}

function RefreshChat()
{
    SmartModeChange(CurrentChatMode);
    //return;    
}

function DisplayChatMessage(string PlayerName, string Message, int ChannelIdx, FoxPRI PRI)
{
    // End:0x42
    if(Outer.PCOwner.IsPlayerNameIgnored(PlayerName))
    {
        return;
    }
    ReplaceHMTLCharacters(Message);
    FilterChat(PlayerName, Message, HandleNewChatMessage, ChannelIdx, PRI);
    //return;    
}

function HandleNewChatMessage(string PlayerName, string PlayerMessage, int ChannelIndex, FoxPRI PRI)
{
    SetUpPlayerNameForChat(PlayerName);
    // End:0x39
    if(ChannelIndex == -1)
    {
        ChannelIndex = CurrentChatMode;
    }
    // End:0xBA
    if(!IsTeamChatAvailable())
    {
        PlayerName = Outer.WrapStringInColor(PlayerName, Outer.NoTeamColor);
        TryUpdateLog(1, PlayerName, PlayerMessage);
    }
    // End:0x2B8
    else
    {
        // End:0x1C6
        if(ChannelIndex == 1)
        {
            PlayerName = Outer.WrapStringInColor(PlayerName, ((Outer.PCOwner.PlayerReplicationInfo.Team == PRI.Team) ? Outer.NoTeamColor : Outer.RedTeamColor));
            TryUpdateLog(1, PlayerName, PlayerMessage);
        }
        // End:0x2B8
        else
        {
            // End:0x2B6
            if((ChannelIndex == 2) && Outer.PCOwner.PlayerReplicationInfo.Team == PRI.Team)
            {
                PlayerName = Outer.WrapStringInColor(PlayerName, Outer.BlueTeamColor);
                TryUpdateLog(2, PlayerName, PlayerMessage);
            }
            // End:0x2B8
            else
            {
                return;
            }
        }
    }
    // End:0x3D6
    if((Outer.HUD != none) && !Outer.PCOwner.IsPlayerNameIgnored(PRI.PlayerName))
    {
        // End:0x3D6
        if(AllChannels[ChannelIndex].IsListenedTo)
        {
            Outer.HUD.PumpChatMessage(PrepHudChatMessage(AllChannels[ChannelIndex].ChannelName, PlayerName, PlayerMessage));
        }
    }
    RefreshChat();
    //return;    
}

function OnSocialServerMessage(string ChannelID, string PlayerName, string Message)
{
    local int Idx;

    // End:0x42
    if(Outer.PCOwner.IsPlayerNameIgnored(PlayerName))
    {
        return;
    }
    Idx = AllChannels.Find('ChannelID', ChannelID);
    // End:0xC8
    if(Idx != -1)
    {
        ReplaceHMTLCharacters(Message);
        FilterChat(PlayerName, Message, HandleSocialServerMessage, Idx, none);
    }
    //return;    
}

private final function HandleSocialServerMessage(string InPlayerName, string Message, int ChannelIndex, FoxPRI PRI)
{
    local string PlayerName;

    PlayerName = InPlayerName;
    SetUpPlayerNameForChat(PlayerName);
    PlayerName = Outer.WrapStringInColor(PlayerName, Outer.NoTeamColor);
    TryUpdateLog(AllChannels[ChannelIndex].Mode, PlayerName, Message);
    // End:0x1AF
    if((Outer.HUD != none) && InPlayerName == Outer.PCOwner.PlayerReplicationInfo.PlayerName)
    {
        Outer.HUD.PumpChatMessage(PrepHudChatMessage(AllChannels[ChannelIndex].ChannelName, PlayerName, Message));
    }
    //return;    
}

function ReceiveWhisper(bool Success, string PlayerName, string Message)
{
    // End:0x42
    if(Outer.PCOwner.IsPlayerNameIgnored(PlayerName))
    {
        return;
    }
    // End:0xE9
    if(!Success)
    {
        UpdateLog(5, Outer.LocalizeChat("ChatErrorStringName"), Outer.LocalizeChat("ChatErrorStringText_OfflineWhisperTarget"), IsActiveLog(5));
        return;
    }
    ReplaceHMTLCharacters(Message);
    FilterChat(PlayerName, Message, WhisperFiltered, -1, none);
    //return;    
}

function WhisperFiltered(string InPlayerName, string Message, int ChannelIdx, FoxPRI ForPRI)
{
    local string PlayerName;

    PlayerName = Repl(InPlayerName, "->", "");
    // End:0x59
    if(PlayerName != ReplyPlayer)
    {
        ReplyPlayer = PlayerName;
        ChangeChatMode(CurrentChatMode);
    }
    SetUpPlayerNameForChat(PlayerName);
    PlayerName = Outer.WrapStringInColor(InPlayerName, Outer.PlayerWhisperColor);
    Message = Outer.WrapStringInColor(Message, Outer.PlayerWhisperColor);
    TryUpdateLog(5, PlayerName, Message);
    // End:0x215
    if((Outer.HUD != none) && !Outer.PCOwner.ProfileSettings.IsFlagEnabled(200, 3))
    {
        Outer.HUD.PumpChatMessage(PrepHudChatMessage(AllChannels[5].ChannelName, PlayerName, Message));
    }
    //return;    
}

function SendWhisper(string PlayerName, string Message)
{
    Outer.ChatInterface.SendWhisper(PlayerName, Message);
    ReplyPlayer = PlayerName;
    ChangeChatMode(CurrentChatMode);
    ReplaceHMTLCharacters(Message);
    FilterChat("->" $ PlayerName, Message, WhisperFiltered, -1, none);
    //return;    
}

function ui_SetUIReadyForDefaultMessage()
{
    UIReadyForDefaultMessage = true;
    //return;    
}

function ui_TryShowDefaultChatMessages()
{
    local string ToDisplay;
    local ClanInfo cInfo;

    // End:0x226
    if(UIReadyForDefaultMessage)
    {
        Outer.Advance(0.0);
        // End:0xE3
        if(!bHasShownHelpMessage)
        {
            bHasShownHelpMessage = true;
            ToDisplay = (Outer.LocalizeChat("ShowHelpText1") @ SlashCommands[SlashCommands.Length - 1]) @ Outer.LocalizeChat("ShowHelpText2");
            UpdateCurrentLog("", ToDisplay, true);
        }
        // End:0x226
        if(Outer.IsInClan() && ClanInterfaceReadyForDefaultMessage || bNewClanMOTD)
        {
            UIReadyForDefaultMessage = false;
            ClanInterfaceReadyForDefaultMessage = false;
            cInfo = Outer.GetClanInfo();
            // End:0x226
            if(cInfo.MOTD != "")
            {
                bNewClanMOTD = false;
                ToDisplay = ("[" $ cInfo.ClanTag) $ "]";
                TryUpdateLog(3, ToDisplay, cInfo.MOTD, true);
                TryUpdateLog(0, ToDisplay, cInfo.MOTD, true);
            }
        }
    }
    //return;    
}

function JoinChatChannel(const string ChannelName)
{
    local int I;

    I = AllChannels.Find('ChannelName', ChannelName);
    // End:0x13B
    if(I != -1)
    {
        // End:0xED
        if(AllChannels[I].bMustJoinOnline)
        {
            Outer.ChatInterface.JoinChatChannelByID(AllChannels[I].ChannelID);
            AllChannels[I].bJoinedManually = true;
        }
        // End:0x138
        else
        {
            EnableChannel(I, true);
            Outer.Advance(0.0);
            SmartModeChange(I);
        }
    }
    // End:0x1CA
    else
    {
        // End:0x18C
        if(AllChannels.Length >= 7)
        {
            UpdateCurrentLog("Error", "Cannot add more chat channels at this time");
            return;
        }
        Outer.ChatInterface.JoinChatChannelByName(ChannelName);
    }
    //return;    
}

event AddChatChannel(const string ChannelID, const string ChannelName)
{
    local ChatRoom NewRoom;
    local int Index;

    Index = AllChannels.Find('ChannelID', ChannelID);
    // End:0xF0
    if(Index != -1)
    {
        EnableChannel(Index, true);
        // End:0xED
        if(AllChannels[Index].bJoinedManually)
        {
            AllChannels[Index].bJoinedManually = false;
            Outer.Advance(0.0);
            CurrentChatMode = Index;
            SmartModeChange(Index);
        }
    }
    // End:0x1E4
    else
    {
        NewRoom.ChannelID = ChannelID;
        NewRoom.ChannelName = ChannelName;
        NewRoom.IsListenedTo = true;
        NewRoom.UnreadCount = 0;
        Index = AllChannels.Length;
        AllChannels.AddItem(NewRoom);
        RefreshButtons();
        Outer.Advance(0.0);
        SmartModeChange(Index);
    }
    //return;    
}

// Export UFoxChatUI::execParseChatList(FFrame&, void* const)
native function ParseChatList(string ChatList);

// Export UFoxChatUI::execPrepareBadWordsArray(FFrame&, void* const)
native function PrepareBadWordsArray();

function LeaveChatChannel(string ChannelName)
{
    local int ChannelIndex;

    ChannelIndex = AllChannels.Find('ChannelName', ChannelName);
    // End:0x3E
    if(ChannelIndex == -1)
    {
        return;
    }
    // End:0x88
    if(CurrentChatMode == ChannelIndex)
    {
        AllChannels[ChannelIndex].IsEnabled = false;
        SwitchToNextAvailableChannel();
    }
    // End:0x134
    if(ChannelIndex < 7)
    {
        EnableChannel(ChannelIndex, false);
        // End:0x131
        if(AllChannels[ChannelIndex].bMustJoinOnline)
        {
            Outer.ChatInterface.LeaveChatChannel(AllChannels[ChannelIndex].ChannelID);
        }
    }
    // End:0x207
    else
    {
        Outer.ChatInterface.LeaveChatChannel(AllChannels[ChannelIndex].ChannelID);
        AllChannels.Remove(ChannelIndex, 1);
        // End:0x1D5
        if(Outer.Menu != none)
        {
            RefreshButtons();
        }
        // End:0x207
        else
        {
            as_RemoveLog(AllChannels[ChannelIndex].Mode);
        }
    }
    //return;    
}

function ei_updateSavedCollapsableChatStatus(int collapseStatus)
{
    Outer.MenuItemsDataStore.SavedCollapsableChatStaus = collapseStatus;
    //return;    
}

function ui_DoChatButtons(int XPos, int YPos)
{
    // End:0xBB
    if(!class'WorldInfo'.static.IsConsoleBuild())
    {
        Outer.UIPanelPath = as_CreateChatPanel(XPos, YPos);
        Outer.as_SetMaxChars(Outer.MaxChatCharacters, Outer.UIPanelPath);
    }
    //return;    
}

function ui_SetDefaultChatChannel()
{
    // End:0x3C
    if(IsLobbyChatAvailable())
    {
        AllChannels[0].bJoinedManually = false;
        SmartModeChange(1);
    }
    // End:0x46
    else
    {
        SwitchToNextAvailableChannel();
    }
    //return;    
}

function SwitchToNextAvailableChannel()
{
    local int Index;

    Index = AllChannels.Find('IsEnabled', true);
    // End:0x47
    if(Index != -1)
    {
        SmartModeChange(Index);
    }
    //return;    
}

function RefreshButtons()
{
    local int I;
    local string Temp;

    // End:0x26
    if(Outer.Menu == none)
    {
        return;
    }
    // End:0x4D
    if(Outer.UIPanelPath == "")
    {
        return;
    }
    I = 0;
    J0x58:
    // End:0xE9 [Loop If]
    if(I < 7)
    {
        // End:0xDB
        if(PendingChatLogs[I] == "")
        {
            Temp = as_QueryChatLogByIndex(I);
            PendingChatLogs[I] = ((Temp == "undefined") ? "" : Temp);
        }
        ++ I;
        // [Loop Continue]
        goto J0x58;
    }
    as_ClearButtons();
    Outer.Advance(0.0);
    CreateChatButtons();
    SmartModeChange(CurrentChatMode);
    ui_TryShowDefaultChatMessages();
    //return;    
}

function NotifySpectatorSwitch()
{
    RefreshButtons();
    //return;    
}

function CreateChatButtons()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x423 [Loop If]
    if(I < AllChannels.Length)
    {
        // End:0xCD
        if(I == 2)
        {
            AllChannels[2].ChannelName = ((IsSpectator()) ? Outer.LocalizeChat("SpectatorChatModeString") : Outer.LocalizeChat("TeamChatModeString"));
        }
        // End:0x1A9
        if((Outer.Menu != none) && Outer.UIPanelPath != "")
        {
            AllChannels[I].UIButtonPath = as_AddChatButton("", "ei_chatTabClicked", AllChannels[I].Mode, "", Outer.UIPanelPath);
        }
        // End:0x1DB
        else
        {
            as_AddChatLog(AllChannels[I].Mode);
        }
        Outer.Advance(0.0);
        SetUnreadCount(AllChannels[I]);
        Outer.Advance(0.0);
        // End:0x3BF
        if((((((Outer.PCOwner.ProfileSettings.IsFlagEnabled(200, 6) || AllChannels[I].IsListenedTo == false) || (I == 0) && !IsGlobalChatAvailable()) || (I == 1) && !IsLobbyChatAvailable()) || (I == 2) && !IsTeamChatAvailable()) || (I == 3) && !Outer.IsInClan()) || (I == 4) && !Outer.PartyCache.AreWeInAParty())
        {
            SetButtonEnabled(I, false);
        }
        // End:0x415
        if(PendingChatLogs[I] != "")
        {
            as_ReloadChatLogByIndex(I, PendingChatLogs[I]);
            PendingChatLogs[I] = "";
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function ClearGameSpecificLogs()
{
    as_ClearLog(1);
    as_ClearLog(2);
    //return;    
}

function ClearDefaultLogs(bool IgnoringThis)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x3C [Loop If]
    if(I < 7)
    {
        as_ClearLog(I);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 7;
    J0x48:
    // End:0x81 [Loop If]
    if(I < AllChannels.Length)
    {
        as_RemoveLog(I);
        ++ I;
        // [Loop Continue]
        goto J0x48;
    }
    //return;    
}

function SetUnreadCount(ChatRoom Channel)
{
    local string NewName;

    NewName = ((Channel.UnreadCount == 0) ? Channel.ChannelName : ((Channel.ChannelName @ "[") $ string(Channel.UnreadCount)) $ "]");
    // End:0xFF
    if(Outer.Menu != none)
    {
        Outer.as_SetStringParam(NewName, "label", Channel.UIButtonPath);
    }
    //return;    
}

function SmartModeChange(int NewMode)
{
    // End:0x2E
    if(!AllChannels[NewMode].IsListenedTo)
    {
        return;
    }
    // End:0x68
    if(Outer.Menu != none)
    {
        ChangeChatMode(NewMode);
    }
    // End:0x7B
    else
    {
        ChangeChatMode(NewMode);
    }
    //return;    
}

function ReplaceHMTLCharacters(out string ToClean)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x6D [Loop If]
    if(I < HTMLSanitized.Length)
    {
        ToClean = Repl(ToClean, HTMLUnsanitized[I], HTMLSanitized[I], true);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

event TryUpdateLog(int Index, string PlayerName, string Message, optional bool DoNotIncrementUnread)
{
    // End:0x6D
    if(AllChannels[Index].IsListenedTo)
    {
        UpdateLog(Index, PlayerName, Message, IsActiveLog(Index), DoNotIncrementUnread);
    }
    //return;    
}

event UpdateCurrentLog(string LogName, string LogMessage, optional bool DoNotIncrementUnread)
{
    UpdateLog(CurrentChatMode, LogName, LogMessage, Outer.Menu != none, DoNotIncrementUnread);
    //return;    
}

function AddSocialNotification(string DisplayString)
{
    UpdateCurrentLog("", DisplayString);
    //return;    
}

function string GetCurrentChannelName()
{
    return ((AllChannels[CurrentChatMode].ChannelName @ "(") $ (GetChatCommandForCurrentChannel())) @ "):";
    //return ReturnValue;    
}

function string GetChatCommandForCurrentChannel()
{
    switch(CurrentChatMode)
    {
        // End:0x27
        case 0:
            return ChatSlashCommands[8];
            // End:0xD6
            break;
        // End:0x3B
        case 1:
            return ChatSlashCommands[2];
            // End:0xD6
            break;
        // End:0x50
        case 2:
            return ChatSlashCommands[4];
            // End:0xD6
            break;
        // End:0x65
        case 3:
            return ChatSlashCommands[6];
            // End:0xD6
            break;
        // End:0x7A
        case 4:
            return ChatSlashCommands[10];
            // End:0xD6
            break;
        // End:0xAC
        case 5:
            // End:0x9F
            if(ReplyPlayer == "")
            {
                return SlashCommands[12];
            }
            // End:0xA9
            else
            {
                return ReplyPlayer;
            }
            // End:0xD6
            break;
        // End:0xC1
        case 6:
            return ChatSlashCommands[12];
            // End:0xD6
            break;
        // End:0xFFFF
        default:
            return string(CurrentChatMode + 1);
    }
    goto J0xD6;
    //return ReturnValue;    
}

function string PrepHudChatMessage(string ChannelName, string PlayerName, string PlayerMessage)
{
    return (((("{" $ ChannelName) $ "}") @ PlayerName) $ ":") @ PlayerMessage;
    //return ReturnValue;    
}

function EnableChannel(int Index, bool Enabled)
{
    AllChannels[Index].IsListenedTo = Enabled;
    SetButtonEnabled(Index, Enabled);
    //return;    
}

function SetButtonEnabled(int Index, bool Enabled)
{
    local string Temp;

    AllChannels[Index].IsEnabled = Enabled;
    // End:0xA7
    if(Outer.Menu != none)
    {
        Outer.as_DisableButton(!Enabled, AllChannels[Index].UIButtonPath);
    }
    // End:0x118
    if(PendingChatLogs[Index] == "")
    {
        Temp = as_QueryChatLogByIndex(Index);
        PendingChatLogs[Index] = ((Temp == "undefined") ? "" : Temp);
    }
    as_ClearLog(Index);
    //return;    
}

function UpdateLog(int Index, string PlayerName, string Message, bool bIsActiveLog, optional bool DoNotIncrementUnread)
{
    as_UpdateLog(Index, PlayerName, Message, bIsActiveLog);
    DoNotIncrementUnread = DoNotIncrementUnread || Outer.PCOwner.PlayerReplicationInfo.PlayerName == PlayerName;
    // End:0x102
    if(!bIsActiveLog && !DoNotIncrementUnread)
    {
        ++ AllChannels[Index].UnreadCount;
        SetUnreadCount(AllChannels[Index]);
    }
    // End:0x13F
    if(Index == CurrentChatMode)
    {
        as_PruneChatLog(Index, ChatPruneLimits[Index]);
    }
    //return;    
}

function SetUpPlayerNameForChat(out string PlayerName)
{
    PlayerName = ((("<a href='asfunction:_root.chatLink," $ PlayerName) $ "'>[") $ PlayerName) $ "]</a>";
    //return;    
}

function ei_chatLink(string LinkedName)
{
    // End:0x64
    if(LinkedName != Outer.PlayerInterface.GetPlayerNickname(0))
    {
        ReplyPlayer = LinkedName;
        SmartModeChange(5);
    }
    //return;    
}

function StartChatTimer()
{
    ChatTimerRemaining = TimeCycle;
    //return;    
}

function ClearChatTimer()
{
    ChatTimerRemaining = 0.0;
    //return;    
}

event ChatTimerFinished()
{
    ChatTimerRemaining = 0.0;
    OutstandingChatMessages = 0;
    //return;    
}

function as_UpdateHUDInputString(string Label)
{
    Outer.ActionScriptVoid("_root.updateHUDChatInputString");
    //return;    
}

function string as_CreateChatPanel(int XPos, int YPos)
{
    return Outer.ActionScriptString("_root.addChatPanel");
    //return ReturnValue;    
}

function as_SetInputText(string Label, string PanelPath)
{
    Outer.SetVariableString(PanelPath $ ".sayText", Label);
    //return;    
}

function string as_AddChatButton(string Label, string ClickInterface, int LogIndex, string TransitionType, string PanelPath)
{
    return Outer.ActionScriptString(PanelPath $ ".addChatButton");
    //return ReturnValue;    
}

function as_AddChatLog(int LogIndex)
{
    Outer.ActionScriptVoid("_root.addChatLog");
    //return;    
}

function as_RemoveButton(int Index, string PanelPath)
{
    Outer.ActionScriptVoid(PanelPath $ ".removeButton");
    //return;    
}

function as_ClearButtons()
{
    Outer.ActionScriptVoid(Outer.UIPanelPath $ ".clearButtonList");
    //return;    
}

function as_ShowChat(int Index)
{
    Outer.ActionScriptVoid(Outer.UIPanelPath $ ".showChat");
    //return;    
}

function as_CreateLog(int Index)
{
    Outer.ActionScriptVoid("_root.addChatLog");
    //return;    
}

function as_RemoveLog(int Index)
{
    Outer.ActionScriptVoid("_root.removeChatLog");
    //return;    
}

function as_ClearLog(int Index)
{
    Outer.ActionScriptVoid("_root.clearChatLog");
    //return;    
}

function as_UpdateLog(int Index, string PlayerName, string Message, bool IsActiveLog)
{
    Outer.ActionScriptVoid("_root.updateChatLog");
    //return;    
}

function string as_QueryChatLogByIndex(int ChatLogIndex)
{
    return Outer.ActionScriptString("_root.queryChatLog");
    //return ReturnValue;    
}

function int as_QueryCollaspableChatStatus()
{
    return Outer.ActionScriptInt("_root.queryChatCollapseStatus");
    //return ReturnValue;    
}

function as_ReloadChatLogByIndex(int ChatLogIndex, string ChatToReload)
{
    Outer.ActionScriptVoid("_root.reloadChatLog");
    //return;    
}

function string as_QueryPreservedChat()
{
    return Outer.ActionScriptString("_root.queryPreservedChat");
    //return ReturnValue;    
}

function as_ReloadPreservedChat(string ChatToReload)
{
    Outer.ActionScriptVoid("setPreservedChat");
    //return;    
}

function as_PruneChatLog(int ChatLogIndex, int MaxLines)
{
    Outer.ActionScriptVoid("pruneChatLog");
    //return;    
}

defaultproperties
{
    HTMLUnsanitized(0)="<"
    HTMLUnsanitized(1)=">"
    HTMLSanitized(0)="&lt;"
    HTMLSanitized(1)="&gt;"
    FilteredChatString="!@#$%&!@#$%&!@#$%&!@#$%&!@#$%&!@#$%&"
    ChatSlashCommands(0)="/s "
    ChatSlashCommands(1)="/say "
    ChatSlashCommands(2)="/l "
    ChatSlashCommands(3)="/lobby "
    ChatSlashCommands(4)="/t "
    ChatSlashCommands(5)="/team "
    ChatSlashCommands(6)="/c "
    ChatSlashCommands(7)="/clan "
    ChatSlashCommands(8)="/g "
    ChatSlashCommands(9)="/global "
    ChatSlashCommands(10)="/p "
    ChatSlashCommands(11)="/party "
    ChatSlashCommands(12)="/h "
    ChatSlashCommands(13)="/help "
    SlashCommands(0)="/exit"
    SlashCommands(1)="/quit"
    SlashCommands(2)="/join "
    SlashCommands(3)="/leave "
    SlashCommands(4)="/cinvite "
    SlashCommands(5)="/claninvite "
    SlashCommands(6)="/cquit"
    SlashCommands(7)="/clanquit"
    SlashCommands(8)="/cdisband"
    SlashCommands(9)="/clandisband"
    SlashCommands(10)="/clankick "
    SlashCommands(11)="/ckick "
    SlashCommands(12)="/w "
    SlashCommands(13)="/whisper "
    SlashCommands(14)="/r "
    SlashCommands(15)="/reply "
    SlashCommands(16)="/friend "
    SlashCommands(17)="/i "
    SlashCommands(18)="/ignore "
    SlashCommands(19)="/u "
    SlashCommands(20)="/unignore "
    SlashCommands(21)="/twitterlogin "
    SlashCommands(22)="/tweet "
    SlashCommands(23)="/ban "
    SlashCommands(24)="/b "
    SlashCommands(25)="/unban "
    SlashCommands(26)="/ub "
    SlashCommands(27)="/kick "
    SlashCommands(28)="/k "
    SlashCommands(29)="/allowplayer "
    SlashCommands(30)="/ap "
    SlashCommands(31)="/allowclan "
    SlashCommands(32)="/ac "
    SlashCommands(33)="/addadmin "
    SlashCommands(34)="/aa "
    SlashCommands(35)="/removeadmin "
    SlashCommands(36)="/ra "
    SlashCommands(37)="/help"
    CurrentChatMode=1
    MaxOutstandingChatMessages=3
    TimeCycle=7.0
    ChatPruneLimits[0]=100
    ChatPruneLimits[1]=50
    ChatPruneLimits[2]=50
    ChatPruneLimits[3]=50
    ChatPruneLimits[4]=50
    ChatPruneLimits[5]=50
    ChatPruneLimits[6]=50
}